/*
 * (C) 2007-2012 Alibaba Group Holding Limited.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * Authors:
 *   wuhua <wq163@163.com> , boyan <killme2008@gmail.com>
 */
package com.taobao.metamorphosis.client.consumer;

import com.taobao.metamorphosis.client.MetaClientConfig;


/**
 * ãҪѡ£
 * <ul>
 * <li>group:ƣ룬ʾڷ飬ͬһ²ظϢͬĳһtopic</li>
 * <li>consumerId: idΨһʶһߣɲãϵͳݷԶ</li>
 * <li>commitOffsetPeriodInMills: offsetʱĬ5룬λ</li>
 * <li>fetchTimeoutInMills: ͬȡϢĬϳʱʱ䣬Ĭ10룬λ</li>
 * <li>maxDelayFetchTimeInMills: ȡϢʧܵʱ򣨰get
 * missκ쳣)ӳٻȡֵӳʱ䣬λ</li>
 * <li>fetchRunnerCount: ȡϢ߳Ĭcpu</li>
 * <li>partition:ʹֱģʽʱֵָӵķ"brokerId-partition"ַ</li>
 * <li>offset:ָȡoffsetƫ,Ĭϴ0ʼ</li>
 * <li>maxFetchRetries:ͬһϢڴʧԴĬ5ΣϢ¼</li>
 * <li>maxIncreaseFetchDataRetries:ȡԴֵ,ÿȡ</li>
 * <li>loadBalanceStrategyType: ߸ؾ</li>
 * </ul>
 * 
 * @author boyan
 * @Date 2011-4-28
 * @author wuhua
 * 
 */
public class ConsumerConfig extends MetaClientConfig {
    static final long serialVersionUID = -1L;
    private int fetchRunnerCount = Runtime.getRuntime().availableProcessors();
    private long maxDelayFetchTimeInMills = 5000;
    @Deprecated
    private long maxDelayFetchTimeWhenExceptionInMills = 10000;
    private long fetchTimeoutInMills = 10000;
    private String consumerId;
    private String partition;
    private long offset = 0;
    private String group;
    private long commitOffsetPeriodInMills = 5000L;
    private int maxFetchRetries = 5;
    private LoadBalanceStrategy.Type loadBalanceStrategyType = LoadBalanceStrategy.Type.DEFAULT;

    // ϢʧԸȡݲԷֿ,
    // ΪʱҪʧ(maxFetchRetriesΪmaxIntValue),
    // Ҫȡ
    private int maxIncreaseFetchDataRetries = 5;


    public int getMaxFetchRetries() {
        return this.maxFetchRetries;
    }


    public void setMaxFetchRetries(final int maxFetchRetries) {
        this.maxFetchRetries = maxFetchRetries;
    }


    /**
     * ȡԴֵ,ÿȡ
     * 
     * @return
     */
    public int getMaxIncreaseFetchDataRetries() {
        return this.maxIncreaseFetchDataRetries;
    }


    /**
     * ȡԴֵ,ÿȡ
     * 
     * @param maxFetchRetriesForDataNotEnough
     */
    public void setMaxIncreaseFetchDataRetries(final int maxFetchRetriesForDataNotEnough) {
        this.maxIncreaseFetchDataRetries = maxFetchRetriesForDataNotEnough;
    }


    /**
     * 
     * @param group
     *            
     */
    public ConsumerConfig(final String group) {
        super();
        this.group = group;
    }


    /**
     * 
     * @param consumerId
     *            idãϵͳԶ "ip_ʱ"
     * @param group
     */
    public ConsumerConfig(final String consumerId, final String group) {
        super();
        this.consumerId = consumerId;
        this.group = group;
    }


    public ConsumerConfig() {
        super();
    }


    /**
     * ߳Ĭcpus
     * 
     * @return
     */
    public int getFetchRunnerCount() {
        return this.fetchRunnerCount;
    }


    /**
     * offset
     * 
     * @return
     */
    public long getOffset() {
        return this.offset;
    }


    /**
     * offset
     * 
     * @param offset
     */
    public void setOffset(final long offset) {
        this.offset = offset;
    }


    /**
     * ״ζϢʵƫʼȡ
     * 
     * @param offset
     */
    public void setConsumeFromMaxOffset() {
        this.setOffset(Long.MAX_VALUE);
    }


    /**
     * ߷
     * 
     * @return
     */
    public String getGroup() {
        return this.group;
    }


    /**
     * ߷
     * 
     * @param group
     *            Ϊ
     */
    public void setGroup(final String group) {
        this.group = group;
    }


    /**
     * ֱӷʱЧ
     * 
     * @return
     */
    public String getPartition() {
        return this.partition;
    }


    /**
     * ÷,ֱӷʱЧ
     * 
     * @param partition
     *            "brokerId-partition"ַ
     */
    public void setPartition(final String partition) {
        this.partition = partition;
    }


    /**
     * id
     * 
     * @return
     */
    public String getConsumerId() {
        return this.consumerId;
    }


    /**
     * idɲãϵͳ"ip_ʱ"ĹԶ
     * 
     * @param consumerId
     */
    public void setConsumerId(final String consumerId) {
        this.consumerId = consumerId;
    }


    /**
     * ʱʱ䣬ΪλĬ10
     * 
     * @return
     */
    public long getFetchTimeoutInMills() {
        return this.fetchTimeoutInMills;
    }


    /**
     * ʱʱ䣬ΪλĬ10
     * 
     * @param fetchTimeoutInMills
     *            
     */
    public void setFetchTimeoutInMills(final long fetchTimeoutInMills) {
        this.fetchTimeoutInMills = fetchTimeoutInMills;
    }


    /**
     * ʱ䣬λ룬Ĭ5
     * 
     * @return
     */
    public long getMaxDelayFetchTimeInMills() {
        return this.maxDelayFetchTimeInMills;
    }


    /**
     * ʱ䣬λ룬Ĭ5
     * 
     * @param maxDelayFetchTimeInMills
     */
    public void setMaxDelayFetchTimeInMills(final long maxDelayFetchTimeInMills) {
        this.maxDelayFetchTimeInMills = maxDelayFetchTimeInMills;
    }


    /**
     * 쳣ʱ(޿ӵ),ʱ䣬λ룬Ĭ10
     * 
     * @deprecated 1.4ʼϳʹmaxDelayFetchTimeInMills
     * @return
     */
    @Deprecated
    public long getMaxDelayFetchTimeWhenExceptionInMills() {
        return this.maxDelayFetchTimeWhenExceptionInMills;
    }


    /**
     * 쳣ʱ(޿ӵ),ʱ䣬λ룬Ĭ10
     * 
     * @deprecated 1.4ʼϳʹmaxDelayFetchTimeInMills
     * @param maxDelayFetchTimeWhenExceptionInMills
     */
    @Deprecated
    public void setMaxDelayFetchTimeWhenExceptionInMills(final long maxDelayFetchTimeWhenExceptionInMills) {
        this.maxDelayFetchTimeWhenExceptionInMills = maxDelayFetchTimeWhenExceptionInMills;
    }


    /**
     * ߳Ĭcpus
     * 
     * @param fetchRunnerCount
     */
    public void setFetchRunnerCount(final int fetchRunnerCount) {
        this.fetchRunnerCount = fetchRunnerCount;
    }


    /**
     * offsetļʱ䣬λ룬Ĭ5
     * 
     * @return
     */
    public long getCommitOffsetPeriodInMills() {
        return this.commitOffsetPeriodInMills;
    }


    /**
     * ñoffsetļʱ䣬λ룬Ĭ5
     * 
     * @param commitOffsetPeriodInMills
     *            
     */
    public void setCommitOffsetPeriodInMills(final long commitOffsetPeriodInMills) {
        this.commitOffsetPeriodInMills = commitOffsetPeriodInMills;
    }


    /**
     * ȡؾ
     * 
     * @return
     */
    public LoadBalanceStrategy.Type getLoadBalanceStrategyType() {
        return this.loadBalanceStrategyType;
    }


    /**
     * øؾ
     * 
     * @param loadBalanceStrategyType
     */
    public void setLoadBalanceStrategyType(final LoadBalanceStrategy.Type loadBalanceStrategyType) {
        this.loadBalanceStrategyType = loadBalanceStrategyType;
    }

}